using System;
using System.Collections.Generic;
using System.Drawing;
using System.Xml;
using System.Net;
using System.IO;

namespace KyoNoTenki
{
    public class LWWS
    {
        // tB[h
        string _tenki; // F܎XJ
        string _title; // Fs  - ̓VC
        string _link;  // Fhttp://weather.livedoor.com/area/13/63.html?v=1
        bool _available; // f[^擾łtrue
        DateTime _publicTime; // \̔\
        Icon _icon; // ^XNgCp̃ACR

        // vpeB
        public string Tenki { get { return _tenki; } }
        public string Title { get { return _title; } }
        public string Link { get { return _link; } }
        public bool Available { get { return _available; } }
        public DateTime PublicTime { get { return _publicTime; } }
        public Icon Icon { get { return _icon; } }

        string lwwsUrl; // VCWebT[rXURL
        Dictionary<string, Icon> IconCache;

        // RXgN^
        public LWWS(int id)
        {
            string lwws = "http://weather.livedoor.com/forecast/webservice/rest/v1?city={0}&day=today";
            lwwsUrl = String.Format(lwws, id);

            IconCache = new Dictionary<string, Icon>();
        }

        public void Refresh()
        {
            _available = false;

            ////////////////////////////////////////
            // XMLf[^̎擾Ɖ
            XmlDocument doc = new XmlDocument();
            try
            {
                doc.Load(lwwsUrl);
            }
            catch
            {
                return;
            }
            _title = doc.DocumentElement.SelectSingleNode("/lwws/title").InnerText;
            _tenki = doc.DocumentElement.SelectSingleNode("/lwws/image/title").InnerText;
            _link = doc.DocumentElement.SelectSingleNode("/lwws/image/link").InnerText;
            string imageURL = doc.DocumentElement.SelectSingleNode("/lwws/image/url").InnerText;
            string pt = doc.DocumentElement.SelectSingleNode("/lwws/publictime").InnerText;
            _publicTime = DateTime.Parse(pt);

            ////////////////////////////////////////
            // ACR̍쐬
            if (IconCache.ContainsKey(_tenki))
            {
                // łɍ쐬ς
                _icon = IconCache[_tenki];
            }
            else
            {
                _icon = makeIconFromLWWSGif(imageURL);
                if (_icon == null)
                {
                    return;
                }
                // VKǉ
                IconCache[_tenki] = _icon;
            }
            _available = true;
        }

        // urlŎw肳ꂽGIF摜ACR쐬
        Icon makeIconFromLWWSGif(string url)
        {
            // GIF摜rbg}bv
            Bitmap origBitmap;

            // ^XNgCEACRrbg}bv
            // iTCY16x16j
            Bitmap iconBitmap = new Bitmap(16, 16);

            // GIF摜擾ărbg}bv쐬
            using (WebClient wc = new WebClient())
            {
                Stream st;
                try
                {
                    st = wc.OpenRead(url);
                }
                catch
                {
                    return null;
                }
                origBitmap = (Bitmap)Bitmap.FromStream(st);
            }

            // GIF摜݂̒̂ACRɕ`
            Rectangle src = new Rectangle(
                10, 0, origBitmap.Width - 18, origBitmap.Height);
            int height = src.Height * 16 / src.Width;
            Rectangle dest = new Rectangle(0, (16 - height) / 2, 16, height);

            using (Graphics g = Graphics.FromImage(iconBitmap))
            {
                g.Clear(Color.White);
                g.DrawImage(origBitmap, dest, src, GraphicsUnit.Pixel);
                origBitmap.Dispose();
            }

            // BitmapIuWFNgIconIuWFNg쐬
            Icon icon = Icon.FromHandle(iconBitmap.GetHicon());

            origBitmap.Dispose();
            iconBitmap.Dispose();

            return icon;
        }
    }
}
